> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create a workbook

POST https://api.sigmacomputing.com/v2/workbooks
Content-Type: application/json

This endpoint lets you create an empty workbook in Sigma, letting you start a data analysis project or report without any pre-existing templates or data sources set up.

### Usage notes
- The `name` parameter is required to provide a name for the new workbook.
- Use the **folderId** to specify the folder in which to save the workbook. Retrieve the **folderId** by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint and reviewing the `id` field in the response for files with a `type` of `folder`.

### Usage scenarios
- **Project initialization**: When starting a new project that requires data analysis or reporting, users can quickly generate a new blank workbook to begin structuring their data and analyses.
- **Template preparation**: Administrators or team leads might create blank workbooks to set up standardized templates that their teams can use to maintain consistency in data handling and reporting.

### Best practices
- **Naming conventions**: Establish and follow consistent naming conventions for workbooks to make it easier to manage and identify them within larger projects.
- **Folder organization**: Use the **folderId** to organize workbooks into relevant folders, which helps in maintaining a tidy workspace, especially in environments with multiple users or teams.
- **Access control**: Regularly review and manage access permissions for new workbooks, ensuring that only the appropriate personnel can view or edit sensitive data.

Reference: https://help.sigmacomputing.com/reference/create-workbook

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks:
    post:
      operationId: createWorkbook
      summary: Create a workbook
      description: >-
        This endpoint lets you create an empty workbook in Sigma, letting you
        start a data analysis project or report without any pre-existing
        templates or data sources set up.


        ### Usage notes

        - The `name` parameter is required to provide a name for the new
        workbook.

        - Use the **folderId** to specify the folder in which to save the
        workbook. Retrieve the **folderId** by calling the
        [/v2/files](https://help.sigmacomputing.com/reference/list-files)
        endpoint and reviewing the `id` field in the response for files with a
        `type` of `folder`.


        ### Usage scenarios

        - **Project initialization**: When starting a new project that requires
        data analysis or reporting, users can quickly generate a new blank
        workbook to begin structuring their data and analyses.

        - **Template preparation**: Administrators or team leads might create
        blank workbooks to set up standardized templates that their teams can
        use to maintain consistency in data handling and reporting.


        ### Best practices

        - **Naming conventions**: Establish and follow consistent naming
        conventions for workbooks to make it easier to manage and identify them
        within larger projects.

        - **Folder organization**: Use the **folderId** to organize workbooks
        into relevant folders, which helps in maintaining a tidy workspace,
        especially in environments with multiple users or teams.

        - **Access control**: Regularly review and manage access permissions for
        new workbooks, ensuring that only the appropriate personnel can view or
        edit sensitive data.
      tags:
        - Workbooks
      parameters:
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/workbooks_createWorkbook_Response_200'
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                folderId:
                  type: string
                  description: ID of the folder where the new workbook is created.
                name:
                  type: string
                  description: Name of the new workbook.
                description:
                  type: string
                  description: Description of the workbook.
                ownerId:
                  type: string
                  description: ID of the user (member) to own the workbook.
              required:
                - folderId
                - name
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksPostResponsesContentApplicationJsonSchemaTagsItems:
      type: object
      properties:
        versionTagId:
          type: string
          description: Unique identifier of the tag.
        name:
          type: string
        sourceWorkbookVersion:
          type: number
          format: double
        taggedWorkbookId:
          type: string
          description: Unique identifier of the tagged workbook.
        workbookTaggedAt:
          type: string
          format: date-time
      required:
        - versionTagId
        - name
        - sourceWorkbookVersion
        - taggedWorkbookId
        - workbookTaggedAt
      title: V2WorkbooksPostResponsesContentApplicationJsonSchemaTagsItems
    workbooks_createWorkbook_Response_200:
      type: object
      properties:
        workbookId:
          type: string
          description: Unique identifier of the workbook.
        workbookUrlId:
          type: string
        name:
          type: string
        url:
          type: string
        path:
          type: string
        latestVersion:
          type: number
          format: double
        ownerId:
          type: string
        createdBy:
          type: string
          description: The identifier of the user who created this object.
        updatedBy:
          type: string
          description: The identifier of the user or process that last updated this object.
        createdAt:
          type: string
          format: date-time
          description: When the object was created.
        updatedAt:
          type: string
          format: date-time
          description: When the object was last updated.
        isArchived:
          type: boolean
        tags:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksPostResponsesContentApplicationJsonSchemaTagsItems
        description:
          type: string
      required:
        - workbookId
        - workbookUrlId
        - name
        - url
        - path
        - latestVersion
        - ownerId
        - createdBy
        - updatedBy
        - createdAt
        - updatedAt
      title: workbooks_createWorkbook_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples

### Response Example



**Request**

```json
undefined
```

**Response**

```json
{
  "workbookId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "workbookUrlId": "57a96EMo3GVJG73179MV2l",
  "name": "My new Workbook",
  "url": "https://example.com/workbooks/88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "path": "folder1",
  "latestVersion": 1,
  "ownerId": "user1",
  "createdBy": "user1",
  "updatedBy": "user2",
  "createdAt": "2022-01-01T00:00:00.000Z",
  "updatedAt": "2023-01-01T00:00:00.000Z",
  "isArchived": false
}
```

**SDK Code**

```python Response Example
import requests

url = "https://api.sigmacomputing.com/v2/workbooks"

headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Response Example
const url = 'https://api.sigmacomputing.com/v2/workbooks';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Response Example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Response Example
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Response Example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .asString();
```

```php Response Example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks', [
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Response Example
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Response Example
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Create a blank workbook



**Request**

```json
{
  "folderId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "name": "My new blank Workbook",
  "description": "This is a description",
  "ownerId": "FFFFFFFFFFFFFFF99999999999999"
}
```

**Response**

```json
{
  "workbookId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "workbookUrlId": "57a96EMo3GVJG73179MV2l",
  "name": "My new Workbook",
  "url": "https://example.com/workbooks/88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "path": "folder1",
  "latestVersion": 1,
  "ownerId": "user1",
  "createdBy": "user1",
  "updatedBy": "user2",
  "createdAt": "2022-01-01T00:00:00.000Z",
  "updatedAt": "2023-01-01T00:00:00.000Z",
  "isArchived": false
}
```

**SDK Code**

```python Create a blank workbook
import requests

url = "https://api.sigmacomputing.com/v2/workbooks"

payload = {
    "folderId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
    "name": "My new blank Workbook",
    "description": "This is a description",
    "ownerId": "FFFFFFFFFFFFFFF99999999999999"
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create a blank workbook
const url = 'https://api.sigmacomputing.com/v2/workbooks';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"folderId":"88889999-aaaa-bbbb-cccc-ddddeeeeffff","name":"My new blank Workbook","description":"This is a description","ownerId":"FFFFFFFFFFFFFFF99999999999999"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create a blank workbook
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks"

	payload := strings.NewReader("{\n  \"folderId\": \"88889999-aaaa-bbbb-cccc-ddddeeeeffff\",\n  \"name\": \"My new blank Workbook\",\n  \"description\": \"This is a description\",\n  \"ownerId\": \"FFFFFFFFFFFFFFF99999999999999\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create a blank workbook
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"folderId\": \"88889999-aaaa-bbbb-cccc-ddddeeeeffff\",\n  \"name\": \"My new blank Workbook\",\n  \"description\": \"This is a description\",\n  \"ownerId\": \"FFFFFFFFFFFFFFF99999999999999\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create a blank workbook
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"folderId\": \"88889999-aaaa-bbbb-cccc-ddddeeeeffff\",\n  \"name\": \"My new blank Workbook\",\n  \"description\": \"This is a description\",\n  \"ownerId\": \"FFFFFFFFFFFFFFF99999999999999\"\n}")
  .asString();
```

```php Create a blank workbook
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks', [
  'body' => '{
  "folderId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "name": "My new blank Workbook",
  "description": "This is a description",
  "ownerId": "FFFFFFFFFFFFFFF99999999999999"
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Create a blank workbook
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"folderId\": \"88889999-aaaa-bbbb-cccc-ddddeeeeffff\",\n  \"name\": \"My new blank Workbook\",\n  \"description\": \"This is a description\",\n  \"ownerId\": \"FFFFFFFFFFFFFFF99999999999999\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create a blank workbook
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "folderId": "88889999-aaaa-bbbb-cccc-ddddeeeeffff",
  "name": "My new blank Workbook",
  "description": "This is a description",
  "ownerId": "FFFFFFFFFFFFFFF99999999999999"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```